;;; guile-assimp, foreign interface to libassimp
;;; Copyright (C) 2014 by Javier Sancho Fernandez <jsf at jsancho dot org>
;;;
;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (assimp low-level cimport)
  #:use-module (assimp low-level)
  #:use-module (system foreign)
  #:export (aiImportFile
	    aiMultiplyMatrix4))

(define libassimp (dynamic-link "libassimp"))

(define-syntax define-assimp-function
  (syntax-rules (->)
    ((_ (name arg-type ...) -> return-type)
     (define-foreign-function ((libassimp name) arg-type ...) -> return-type))))

(define-assimp-function (aiImportFile '* unsigned-int) -> '*)
(define-assimp-function (aiMultiplyMatrix4 '* '*) -> void)
