#include <stdlib.h>
#include <stdio.h>

#include <GL/glut.h>

#include <assimp/cimport.h>
#include <assimp/scene.h>
#include <assimp/postprocess.h>

void print_materials(struct aiMaterial** materials, unsigned int num_materials)
{
  int i;

  for (i = 0; i < num_materials; i++)
    {
      printf("Material: %d %d\n", materials[i]->mNumProperties, materials[i]->mNumAllocated);
    }
}

void print_node(const struct aiNode* node)
{
  int i;

  printf("%s: %d %d [", node->mName.data, node->mNumMeshes, node->mNumChildren);
  for (i = 0; i < node->mNumMeshes; i++)
    {
      printf("%d ", node->mMeshes[i]);
    }
  printf("]\n");

  for (i = 0; i < node->mNumChildren; i++)
    {
      print_node(node->mChildren[i]);
    }
}

int main(int argc, char **argv)
{
  const struct aiScene* scene = NULL;
  const struct aiNode* node = NULL;

  scene = aiImportFile("/home/jsancho/Imágenes/fleurOptonl.blend", aiProcessPreset_TargetRealtime_MaxQuality);

  // Materials
  print_materials(scene->mMaterials, scene->mNumMaterials);
  printf("\n");

  node = scene->mRootNode;
  printf("Node:\n  parent: %d\n  children: %d\n  meshes: %d\n", node->mParent, node->mNumChildren, node->mNumMeshes);
  printf("  transformation: %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n", node->mTransformation.a1, node->mTransformation.a2, node->mTransformation.a3, node->mTransformation.a4, node->mTransformation.b1, node->mTransformation.b2, node->mTransformation.b3, node->mTransformation.b4, node->mTransformation.c1, node->mTransformation.c2, node->mTransformation.c3, node->mTransformation.c4, node->mTransformation.d1, node->mTransformation.d2, node->mTransformation.d3, node->mTransformation.d4);

  printf("\n\n");
  print_node(node);
}
